import java.io.IOException;

public class Example {
	public static void main(String [] args) throws IOException{
		//Evaluation is an abstract class with abstract function f(int[]), g(int[]), get_n() 
		//you should inherit Evaluation, e.g. the class FMeasure below
		//when you inherit Evalution class, you need to implement method f(int[]), g(int[]) and get_n()
		Evaluation eval = new FMeasure("data/syn_100.txt","data/syn_100_tar.txt",0.5);
		
		PORM porm = new PORM(eval);
		//you can change iteration number here, default 1000
		porm.set_iter_num(100000);
		//the result will be record in pors.output_file_name
		porm.output_file_name = "porm_result.txt";
		
		Solution solution = porm.run_porm();
		System.out.println("result: " + solution.get_value());
		System.out.println("solution:");
		for (int i = 0; i < eval.get_n(); i ++)
			System.out.print(solution.get_x_copy()[i] ? 1 : 0);
		System.out.println();
	}
}
