import java.util.Random;


public class Solution {

	private boolean [] selected = null;
	private int len;
	private double fit = Double.MAX_VALUE;
	public double f_value;
	public double g_value;
	private int norm;
	
	public double get_value(){
		return fit;
	}
	
	public int get_norm(){
		return norm;
	}
	
	public void set_value(double fit){
		this.fit = fit;
	}
	
	public Solution (int n){
		selected = new boolean[n];
		len = n;
		norm = 0;
	}
	
	public Solution(boolean [] s){
		this.selected = s;
		this.len = s.length;
		this.norm = 0;
		for (int i = 0; i < len; i ++){
			if (s[i]){
				this.norm ++;
			}
		}
	}
	
	public boolean get_state(int i){
		return selected[i];
	}
	
	public void set_state(int i, boolean state){
		this.selected[i] = state;
	}
	
	public boolean [] get_x_ref(){
		return this.selected;
	}
	
	public boolean [] get_x_copy(){
		boolean [] s = new boolean [len];
		for (int i = 0; i < len; i ++)
			s[i] = this.selected[i];
		return s;
	}
	
	public Solution get_copy(){
		Solution s = new Solution(get_x_copy());
		s.fit = this.fit;
		return s;
	}
	
	public Solution mutation(){
		Random rand = new Random();
		double p = 1.0 / len;
		boolean [] arr = this.get_x_copy();
		for (int i = 0; i < len; i ++){
			arr [i] = rand.nextDouble() < p ? true ^ arr [i] : arr [i];
		}
		return new Solution (arr);
	}
	
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append("[");
		for (int i = 0; i < len - 1; i ++){
			sb.append(selected[i] + ",");
		}
		sb.append(selected[len-1] + "]");
		
		return sb.toString();
	}
}
